Index: trunk/SophyaLib/HiStats/histos.cc
===================================================================
--- trunk/SophyaLib/HiStats/histos.cc	(revision 1089)
+++ trunk/SophyaLib/HiStats/histos.cc	(revision 1092)
@@ -1085,39 +1099,39 @@
   if (NBins() < 3) THROW(inconsistentErr);
 
-  int iMax = FindBin(xmax);
+  int_4 iMax = FindBin(xmax);
   if (iMax<0 || iMax>=NBins()) THROW(inconsistentErr);
-  float hmax = data[iMax];
-  float limit = frac*hmax;
+  r_8 hmax = mData[iMax];
+  r_8 limit = frac*hmax;
   if (debug > 1)
     cout << "  Max histo[" << iMax << "] = " << hmax
          << ", limite " << limit << endl;
 
-  int iLow = iMax;
-  while (iLow>=0 && data[iLow]>limit) iLow--;
+  int_4 iLow = iMax;
+  while (iLow>=0 && mData[iLow]>limit) iLow--;
   if( iLow < 0 ) iLow = 0;
 
-  int iHigh = iMax;
-  while (iHigh<NBins() && data[iHigh]>limit) iHigh++;
+  int_4 iHigh = iMax;
+  while (iHigh<NBins() && mData[iHigh]>limit) iHigh++;
   if( iHigh >=NBins() ) iHigh = NBins()-1;
 
-  float xlow   = BinCenter(iLow);
-  float ylow   = data[iLow];
-
-  float xlow1=xlow, ylow1=ylow;
+  r_8 xlow   = BinCenter(iLow);
+  r_8 ylow   = mData[iLow];
+
+  r_8 xlow1=xlow, ylow1=ylow;
   if(iLow+1<NBins()) {
     xlow1  = BinCenter(iLow+1);
-    ylow1  = data[iLow+1];
-  }
-
-  float xhigh  = BinCenter(iHigh);
-  float yhigh  = data[iHigh];
-
-  float xhigh1=xhigh, yhigh1=yhigh;
+    ylow1  = mData[iLow+1];
+  }
+
+  r_8 xhigh  = BinCenter(iHigh);
+  r_8 yhigh  = mData[iHigh];
+
+  r_8 xhigh1=xhigh, yhigh1=yhigh;
   if(iHigh-1>=0) {
     xhigh1 = BinCenter(iHigh-1);
-    yhigh1 = data[iHigh-1];
-  }
-
-  float xlpred,xhpred,wd;
+    yhigh1 = mData[iHigh-1];
+  }
+
+  r_8 xlpred,xhpred,wd;
 
   if(ylow1>ylow) {
@@ -1148,7 +1162,7 @@
   Cf suivant mais im est le bin du maximum de l'histo
 */
-int Histo::EstimeMax(float& xm,int SzPav)
-{
-int im = IMax();
+int_4 Histo::EstimeMax(r_8& xm,int_4 SzPav)
+{
+int_4 im = IMax();
 return EstimeMax(im,xm,SzPav);
 }
@@ -1166,17 +1180,17 @@
   \endverbatim
 */
-int Histo::EstimeMax(int& im,float& xm,int SzPav)
+int_4 Histo::EstimeMax(int& im,r_8& xm,int_4 SzPav)
 {
 xm = 0;
 if( SzPav <= 0 ) return -1;
-if( im < 0 || im >= bins ) return -1;
+if( im < 0 || im >= mBins ) return -1;
 
 if( SzPav%2 == 0 ) SzPav++;
 SzPav = (SzPav-1)/2;
 
-int rc = 0;
-double dxm = 0, wx = 0;
-for(int i=im-SzPav;i<=im+SzPav;i++) {
-  if( i<0 || i>= bins ) {rc=1; continue;}
+int_4 rc = 0;
+r_8 dxm = 0, wx = 0;
+for(int_4 i=im-SzPav;i<=im+SzPav;i++) {
+  if( i<0 || i>= mBins ) {rc=1; continue;}
   dxm += BinCenter(i) * (*this)(i);
   wx  += (*this)(i);
@@ -1198,24 +1212,24 @@
   et a droite (widthD)
 */
-void Histo::EstimeWidthS(float frac,float& widthG,float& widthD)
-{
-int i;
+void Histo::EstimeWidthS(r_8 frac,r_8& widthG,r_8& widthD)
+{
+int_4 i;
 widthG = widthD = -1.;
-if( bins<=1 || frac<=0. || frac>=1. ) return;
-
-int imax = 0;
-float maxi = data[0];
-for(i=1;i<bins;i++) if(data[i]>maxi) {imax=i; maxi=data[i];}
-float xmax = BinCenter(imax);
-float maxf = maxi * frac;
+if( mBins<=1 || frac<=0. || frac>=1. ) return;
+
+int_4 imax = 0;
+r_8 maxi = mData[0];
+for(i=1;i<mBins;i++) if(mData[i]>maxi) {imax=i; maxi=mData[i];}
+r_8 xmax = BinCenter(imax);
+r_8 maxf = maxi * frac;
 
 // recherche du sigma a gauche
 widthG = 0.;
-for(i=imax;i>=0;i--) if( data[i] <= maxf ) break;
+for(i=imax;i>=0;i--) if( mData[i] <= maxf ) break;
 if(i<0) i=0;
 if(i<imax) {
-  if( data[i+1] != data[i] ) {
+  if( mData[i+1] != mData[i] ) {
     widthG = BinCenter(i) + binWidth
-           * (maxf-data[i])/(data[i+1]-data[i]);
+           * (maxf-mData[i])/(mData[i+1]-mData[i]);
     widthG = xmax - widthG;
   } else widthG = xmax - BinCenter(i);
@@ -1224,10 +1238,10 @@
 // recherche du sigma a droite
 widthD = 0.;
-for(i=imax;i<bins;i++) if( data[i] <= maxf ) break;
-if(i>=bins) i=bins-1;
+for(i=imax;i<mBins;i++) if( mData[i] <= maxf ) break;
+if(i>=mBins) i=mBins-1;
 if(i>imax) {
-  if( data[i] != data[i-1] ) {
+  if( mData[i] != mData[i-1] ) {
     widthD = BinCenter(i) - binWidth
-           * (maxf-data[i])/(data[i-1]-data[i]);
+           * (maxf-mData[i])/(mData[i-1]-mData[i]);
     widthD -= xmax;
   } else widthD = BinCenter(i) - xmax;
@@ -1257,5 +1271,5 @@
   \endverbatim
 */
-int  Histo::Fit(GeneralFit& gfit,unsigned short typ_err)
+int_4  Histo::Fit(GeneralFit& gfit,unsigned short typ_err)
 {
 if(NBins()<=0) return -1000;
@@ -1264,9 +1278,9 @@
 GeneralFitData mydata(1,NBins());
 
-for(int i=0;i<NBins();i++) {
-  double x = (double) BinCenter(i);
-  double f = (double) (*this)(i);
-  double saf = sqrt(fabs((double) f)); if(saf<1.) saf=1.;
-  double e=0.;
+for(int_4 i=0;i<NBins();i++) {
+  r_8 x =  BinCenter(i);
+  r_8 f =  (*this)(i);
+  r_8 saf = sqrt(fabs( f)); if(saf<1.) saf=1.;
+  r_8 e=0.;
   if(typ_err==0)      {if(HasErrors()) e=Error(i); else e=1.;}
   else if(typ_err==1) {if(HasErrors()) e=Error(i); else e=saf;}
@@ -1295,7 +1309,7 @@
 TVector<r_8> par = gfit.GetParm();
 Histo h(*this);
-for(int i=0;i<NBins();i++) {
-  double x = (double) BinCenter(i);
-  h(i) -= (float) f->Value(&x,par.Data());
+for(int_4 i=0;i<NBins();i++) {
+  r_8 x =  BinCenter(i);
+  h(i) -=  f->Value(&x,par.Data());
 }
 return h;
@@ -1314,7 +1328,7 @@
 TVector<r_8> par = gfit.GetParm();
 Histo h(*this);
-for(int i=0;i<NBins();i++) {
-  double x = (double) BinCenter(i);
-  h(i) = (float) f->Value(&x,par.Data());
+for(int_4 i=0;i<NBins();i++) {
+  r_8 x =  BinCenter(i);
+  h(i) =  f->Value(&x,par.Data());
 }
 return h;
@@ -1334,20 +1348,20 @@
           sinon : hmin hmax
       pflag < 0 : on imprime les informations (nbin,min,...) sans l'histogramme
-            = 0 : on imprime  "BinCenter(i) data[i]"  (note "... ...")
+            = 0 : on imprime  "BinCenter(i) mData[i]"  (note "... ...")
             bit 0 on : (v=1): numero_bin "... ..."
             bit 1 on : (v=2): "... ..." erreur
   \endverbatim
 */
-void Histo::PrintF(FILE * fp, int hdyn,float hmin, float hmax,int pflag,
-	      int il, int ih)
+void Histo::PrintF(FILE * fp, int_4 hdyn,r_8 hmin, r_8 hmax,int_4 pflag,
+	      int_4 il, int_4 ih)
 {
  
- if( il > ih ) { il = 0; ih = bins-1; }
+ if( il > ih ) { il = 0; ih = mBins-1; }
  if( il < 0 ) il = 0;
- if( ih >= bins ) ih = bins-1;
-
- double dhmin = (double) hmin;
- double dhmax = (double) hmax;
- double hb,hbmn,hbmx;
+ if( ih >= mBins ) ih = mBins-1;
+
+ r_8 dhmin =  hmin;
+ r_8 dhmax =  hmax;
+ r_8 hb,hbmn,hbmx;
 
  if(hdyn==0) hdyn = 100;
@@ -1355,7 +1369,7 @@
  cout << "~Histo::Print  "
       << " nHist=" << nHist << "  nEntries=" << nEntries
-      << "  under=" << under << "  over=" << over << endl;
- cout << "       bins=" << bins
-      << "  min=" << min << "  max=" << max
+      << "  mUnder=" << mUnder << "  mOver=" << mOver << endl;
+ cout << "       mBins=" << mBins
+      << "  min=" << mMin << "  mMax=" << mMax
       << "  binWidth=" << binWidth << endl;
  cout << "       mean=" << Mean() << " r.m.s=" << Sigma() 
@@ -1364,12 +1378,12 @@
  if(hdyn<0 || pflag<0 ) return;
 
- if(dhmax<=dhmin) { if(hmin != 0.) dhmin = (double) VMin(); else dhmin=0.;
-                  dhmax = (double) VMax(); }
+ if(dhmax<=dhmin) { if(hmin != 0.) dhmin =  VMin(); else dhmin=0.;
+                  dhmax =  VMax(); }
  if(dhmin>dhmax) return;
  if(dhmin==dhmax) {dhmin -= 1.; dhmax += 1.;}
- double wb = (dhmax-dhmin) / (double) hdyn;
+ r_8 wb = (dhmax-dhmin) /  hdyn;
 
  // determination de la position de la valeur zero
- int i0 = (int)(-dhmin/wb);
+ int_4 i0 = (int_4)(-dhmin/wb);
 
  // si le zero est dans la dynamique,
@@ -1389,6 +1403,6 @@
        dhmax -= hbmx;
      }
-     wb = (dhmax-dhmin) / (double) hdyn;
-     i0 = (int)(-dhmin/wb);
+     wb = (dhmax-dhmin) /  hdyn;
+     i0 = (int_4)(-dhmin/wb);
    }
  }
@@ -1401,18 +1415,18 @@
 
  // premiere ligne
- {for(int i=0;i<hdyn;i++) s[i] = '=';}
+ {for(int_4 i=0;i<hdyn;i++) s[i] = '=';}
  if( 0 <= i0 && i0 < hdyn ) s[i0] = '0';
  if(pflag&1) fprintf( fp, "====");
  fprintf( fp, "======================");
- if(pflag&2 && err2!=NULL) fprintf( fp, "===========");
+ if(pflag&2 && mErr2!=NULL) fprintf( fp, "===========");
  fprintf( fp, "==%s\n",s);
 
  // histogramme
- {for(int i=il;i<=ih;i++) {
-   for(int k=0;k<hdyn;k++) s[k] = ' ';
+ {for(int_4 i=il;i<=ih;i++) {
+   for(int_4 k=0;k<hdyn;k++) s[k] = ' ';
    hb = (*this)(i);
 
    //choix du bin (hdyn bin entre [dhmin,dhmax[
-   int ii = (int)( (hb-dhmin)/wb );
+   int_4 ii = (int_4)( (hb-dhmin)/wb );
    if(ii<0) ii = 0; else if(ii>=hdyn) ii = hdyn-1;
 
@@ -1424,24 +1438,24 @@
    if(i0<0) {
      // courbe entierement positive
-     for(int k=0;k<=ii;k++) s[k] = 'X';
+     for(int_4 k=0;k<=ii;k++) s[k] = 'X';
    } else if(i0>=hdyn) {
      // courbe entierement negative
-     for(int k=hdyn-1;k>=ii;k--) s[k] = 'X';
+     for(int_4 k=hdyn-1;k>=ii;k--) s[k] = 'X';
    } else {
      // courbe positive et negative
      s[i0] = '|';
-     if(ii>i0)        for(int k=i0+1;k<=ii;k++) s[k] = 'X';
-       else if(ii<i0) for(int k=ii;k<i0;k++)    s[k] = 'X';
+     if(ii>i0)        for(int_4 k=i0+1;k<=ii;k++) s[k] = 'X';
+       else if(ii<i0) for(int_4 k=ii;k<i0;k++)    s[k] = 'X';
           else s[ii] = 'X';
    }
 
    // valeur a mettre dans le bin le plus haut/bas
-   int ib;
-   if(hb>0.) ib = (int)( 10.*(hb-hbmn)/(hbmx-hbmn) );
-     else if(hb<0.) ib = (int)( 10.*(hbmx-hb)/(hbmx-hbmn) );
+   int_4 ib;
+   if(hb>0.) ib = (int_4)( 10.*(hb-hbmn)/(hbmx-hbmn) );
+     else if(hb<0.) ib = (int_4)( 10.*(hbmx-hb)/(hbmx-hbmn) );
        else ib = -1;
    if(ib==-1) s[ii] = '|';
      else if(ib==0) s[ii] = '.';
-       else if(ib>0 && ib<10) s[ii] = (char)((int) '0' + ib);
+       else if(ib>0 && ib<10) s[ii] = (char)((int_4) '0' + ib);
 
    // traitement des saturations +/-
@@ -1451,39 +1465,39 @@
    if(pflag&1) fprintf( fp, "%3d ",i);
    fprintf( fp, "%10.4g %10.4g ",BinCenter(i),hb);
-   if(pflag&2 && err2!=NULL) fprintf( fp, "%10.4g ",Error(i));
+   if(pflag&2 && mErr2!=NULL) fprintf( fp, "%10.4g ",Error(i));
    fprintf( fp, "= %s\n",s);
  }}
 
  // derniere ligne
- for(int i=0;i<hdyn;i++) s[i] = '=';
+ for(int_4 i=0;i<hdyn;i++) s[i] = '=';
  if( 0 <= i0 && i0 < hdyn ) s[i0] = '0';
  if(pflag&1) fprintf( fp, "====");
  fprintf( fp, "======================");
- if(pflag&2 && err2!=NULL) fprintf( fp, "===========");
+ if(pflag&2 && mErr2!=NULL) fprintf( fp, "===========");
  fprintf( fp, "==%s\n",s);
 
  // valeur basse des bins (sur ["ndig-1" digits + signe] =  ndig char (>=3))
- const int ndig = 7;
+ const int_4 ndig = 7;
  char sn[2*ndig+10];
  hb = ( fabs(dhmin) > fabs(dhmax) ) ? fabs(dhmin) : fabs(dhmax);
- int n;
- if( hb > 0. ) n = (int)(log10(hb*1.00000001)); else n = 1;
- double scaledig = pow(10.,(double) ndig-2);
- double expo = scaledig/pow(10.,(double) n);
+ int_4 n;
+ if( hb > 0. ) n = (int_4)(log10(hb*1.00000001)); else n = 1;
+ r_8 scaledig = pow(10.,(r_8) ndig-2);
+ r_8 expo = scaledig/pow(10.,(r_8) n);
  // cout <<"n="<<n<<" hb="<<hb<<" scaledig="<<scaledig<<" expo="<<expo<<endl;
- for(int k=0;k<ndig;k++) {
-   for(int i=0;i<hdyn;i++) s[i] = ' ';
-   {for(int i=0;i<hdyn;i++) {
-     n = (int)( (dhmin + i*wb)*expo );
-     for(int j=0;j<2*ndig+10;j++) sn[j] = ' ';
+ for(int_4 k=0;k<ndig;k++) {
+   for(int_4 i=0;i<hdyn;i++) s[i] = ' ';
+   {for(int_4 i=0;i<hdyn;i++) {
+     n = (int_4)( (dhmin + i*wb)*expo );
+     for(int_4 j=0;j<2*ndig+10;j++) sn[j] = ' ';
      sprintf(sn,"%d%c",n,'\0');
      strip(sn,'B',' ');
      // cout <<"n="<<n<<" sn=("<<sn<<")  l="<<strlen(sn)<<" k="<<k;
-     if( (int) strlen(sn) > k ) s[i] = sn[k];
+     if( (int_4) strlen(sn) > k ) s[i] = sn[k];
      // cout <<"  s=("<<s<<")"<<endl;
    }}
    if(pflag&1) fprintf( fp, "    ");
    fprintf( fp, "                      ");
-   if(pflag&2 && err2!=NULL) fprintf( fp, "           ");
+   if(pflag&2 && mErr2!=NULL) fprintf( fp, "           ");
    fprintf( fp, "  %s\n",s);
  }
@@ -1497,6 +1511,6 @@
   Impression de l'histogramme sur stdout
 */
-void Histo::Print(int hdyn,float hmin, float hmax,int pflag,
-	     int il, int ih)
+void Histo::Print(int_4 hdyn,r_8 hmin, r_8 hmax,int_4 pflag,
+	     int_4 il, int_4 ih)
 {
  Histo::PrintF(stdout, hdyn, hmin, hmax, pflag, il, ih);
@@ -1523,5 +1537,5 @@
 
 // Lecture des valeurs
-is.Get(dobj->bins);
+is.Get(dobj->mBins);
 is.Get(dobj->nEntries);
 int_4 errok;
@@ -1529,21 +1543,21 @@
 
 is.Get(dobj->binWidth);
-is.Get(dobj->min);
-is.Get(dobj->max);
-is.Get(dobj->under);
-is.Get(dobj->over);
+is.Get(dobj->mMin);
+is.Get(dobj->mMax);
+is.Get(dobj->mUnder);
+is.Get(dobj->mOver);
 
 is.Get(dobj->nHist);
 
 // Lecture des donnees Histo 1D
-dobj->data = new float[dobj->bins];
+dobj->mData = new r_8[dobj->mBins];
 is.GetLine(strg, 255);
-is.Get(dobj->data, dobj->bins);
+is.Get(dobj->mData, dobj->mBins);
 
 // Lecture des erreurs
 if(errok) {
   is.GetLine(strg, 255);
-  dobj->err2 = new double[dobj->bins];
-  is.Get(dobj->err2, dobj->bins);
+  dobj->mErr2 = new r_8[dobj->mBins];
+  is.Get(dobj->mErr2, dobj->mBins);
 }
 
@@ -1557,37 +1571,37 @@
 
 // Que faut-il ecrire?
-int_4 errok = (dobj->err2) ? 1 : 0;
+int_4 errok = (dobj->mErr2) ? 1 : 0;
 
 // Ecriture entete pour identifier facilement
-sprintf(strg,"bins=%6d  NEnt=%15d  errok=%1d",dobj->bins,dobj->nEntries,errok);
+sprintf(strg,"mBins=%6d  NEnt=%15d  errok=%1d",dobj->mBins,dobj->nEntries,errok);
 os.PutLine(strg);
-sprintf(strg,"binw=%g  min=%g max=%g",dobj->binWidth,dobj->min,dobj->max);
+sprintf(strg,"binw=%g  mMin=%g mMax=%g",dobj->binWidth,dobj->mMin,dobj->mMax);
 os.PutLine(strg);
-sprintf(strg, "under=%g over=%g nHist=%g",dobj->under,dobj->over,dobj->nHist);
+sprintf(strg, "mUnder=%g mOver=%g nHist=%g",dobj->mUnder,dobj->mOver,dobj->nHist);
 os.PutLine(strg);
 
 // Ecriture des valeurs
-os.Put(dobj->bins);
+os.Put(dobj->mBins);
 os.Put(dobj->nEntries);
 os.Put(errok);
 
 os.Put(dobj->binWidth);
-os.Put(dobj->min);
-os.Put(dobj->max);
-os.Put(dobj->under);
-os.Put(dobj->over);
+os.Put(dobj->mMin);
+os.Put(dobj->mMax);
+os.Put(dobj->mUnder);
+os.Put(dobj->mOver);
 
 os.Put(dobj->nHist);
 
 // Ecriture des donnees Histo 1D
-sprintf(strg,"Histo: Tableau des donnees %d",dobj->bins);
+sprintf(strg,"Histo: Tableau des donnees %d",dobj->mBins);
 os.PutLine(strg);
-os.Put(dobj->data, dobj->bins);
+os.Put(dobj->mData, dobj->mBins);
 
 // Ecriture des erreurs
 if(errok) {
-  sprintf(strg,"Histo: Tableau des erreurs %d",dobj->bins);
+  sprintf(strg,"Histo: Tableau des erreurs %d",dobj->mBins);
   os.PutLine(strg);
-  os.Put(dobj->err2, dobj->bins);
+  os.Put(dobj->mErr2, dobj->mBins);
 }
 
Index: trunk/SophyaLib/HiStats/histos.h
===================================================================
--- trunk/SophyaLib/HiStats/histos.h	(revision 1089)
+++ trunk/SophyaLib/HiStats/histos.h	(revision 1092)
@@ -1,5 +1,5 @@
 // This may look like C code, but it is really -*- C++ -*-
 //
-// $Id: histos.h,v 1.10 2000-07-25 10:20:43 ansari Exp $
+// $Id: histos.h,v 1.11 2000-07-26 13:15:15 ansari Exp $
 //
 
@@ -26,5 +26,6 @@
   // CREATOR / DESTRUCTOR
   Histo();
-  Histo(float xMin, float xMax, int nBin=100);
+  Histo(r_8 xMin, r_8 xMax, int_4 nBin=100);
+  Histo(r_4 xMin, r_4 xMax, int_4 nBin=100);
   Histo(const Histo& H);
   virtual ~Histo();
@@ -35,20 +36,20 @@
   // UPDATING or SETTING
   void Zero();
-  void Add(float x, float w = 1.);
-  void AddBin(int numBin, float w = 1.);
-  void SetBin(float x, float w = 1.);
-  void SetBin(int numBin, float w = 1.);
-  void SetErr2(float x, double e2);
-  void SetErr2(int numBin, double e2);
-  void SetErr(float x, float e);
-  void SetErr(int numBin, float e);
+  void Add(r_8 x, r_8 w = 1.);
+  void AddBin(int_4 numBin, r_8 w = 1.);
+  void SetBin(r_8 x, r_8 w = 1.);
+  void SetBin(int_4 numBin, r_8 w = 1.);
+  void SetErr2(r_8 x, r_8 e2);
+  void SetErr2(int_4 numBin, r_8 e2);
+  void SetErr(r_8 x, r_8 e);
+  void SetErr(int_4 numBin, r_8 e);
   virtual inline void UpdateHisto() const { return;}
 
   // Operators
   Histo& operator = (const Histo& h);
-  Histo& operator *= (double b);
-  Histo& operator /= (double b);
-  Histo& operator += (double b);
-  Histo& operator -= (double b);
+  Histo& operator *= (r_8 b);
+  Histo& operator /= (r_8 b);
+  Histo& operator += (r_8 b);
+  Histo& operator -= (r_8 b);
   Histo& operator += (const Histo& a);
   Histo& operator -= (const Histo& a);
@@ -61,6 +62,6 @@
   void GetError2(TVector<r_8>& v);
   void GetError(TVector<r_8>& v);
-  void PutValue(TVector<r_8>& v, int ierr=0);
-  void PutValueAdd(TVector<r_8> &v, int ierr=0);
+  void PutValue(TVector<r_8>& v, int_4 ierr=0);
+  void PutValueAdd(TVector<r_8> &v, int_4 ierr=0);
   void PutError2(TVector<r_8>& v);
   void PutError2Add(TVector<r_8>& v);
@@ -69,102 +70,102 @@
   // INLINES
   //! Retourne l'abscisse minimum
-  inline float XMin() const {return min;}
+  inline r_8 XMin() const {return mMin;}
   //! Retourne l'abscisse maximum
-  inline float XMax() const {return max;}
+  inline r_8 XMax() const {return mMax;}
   //! Retourne le nombre de bins
-  inline int_4 NBins() const {return bins;}
+  inline int_4 NBins() const {return mBins;}
   //! Retourne la largeur du bin
-  inline float BinWidth() const {return binWidth;}
+  inline r_8 BinWidth() const {return binWidth;}
   //! Retourne le pointeur sur le tableaux des contenus
-  inline float* Bins() const {return data;}
+  inline r_8* Bins() const {return mData;}
   //! Retourne le contenu du bin i
-  inline float operator()(int i) const  {return data[i];}
+  inline r_8 operator()(int_4 i) const  {return mData[i];}
   //! Remplit le contenu du bin i
-  inline float& operator()(int i) {return data[i];}
+  inline r_8& operator()(int_4 i) {return mData[i];}
   //! retourne "true" si il y a des erreurs stoquees
   inline bool HasErrors()
-         {if(err2) return true; else return false;}
+         {if(mErr2) return true; else return false;}
   //! Retourne l'erreur du bin i
-  inline float Error(int i) const
-         {if(err2) {if(err2[i]>0.) return sqrt(err2[i]); else return 0.;}
+  inline r_8 Error(int_4 i) const
+         {if(mErr2) {if(mErr2[i]>0.) return sqrt(mErr2[i]); else return 0.;}
                     else return 0.;}
   //! Retourne l'erreur au carre du bin i
-  inline double Error2(int i) const
-         {if(err2) return err2[i]; else return 0.;}
+  inline r_8 Error2(int_4 i) const
+         {if(mErr2) return mErr2[i]; else return 0.;}
   //! Remplit l'erreur au carre du bin i
-  inline double& Error2(int i) {return err2[i];}
+  inline r_8& Error2(int_4 i) {return mErr2[i];}
   //! Retourne la somme ponderee
-  inline float NData() const            {return (float) nHist;}
+  inline r_8 NData() const            {return nHist;}
   //! Retourne le nombre d'entrees
-  inline float NEntries() const         {return nEntries;}
+  inline r_8 NEntries() const         {return nEntries;}
   //! Retourne le nombre d'overflow
-  inline float NOver() const            {return over;}
+  inline r_8 NOver() const            {return mOver;}
   //! Retourne le nombre d'underflow
-  inline float NUnder() const           {return under;}
+  inline r_8 NUnder() const           {return mUnder;}
 
   //! Retourne l'abscisse du bord inferieur du bin i
-  inline float BinLowEdge(int i)  const {return min + i*binWidth;}
+  inline r_8 BinLowEdge(int_4 i)  const {return mMin + i*binWidth;}
   //! Retourne l'abscisse du centre du bin i
-  inline float BinCenter(int i)   const {return min + (i+0.5)*binWidth;}
+  inline r_8 BinCenter(int_4 i)   const {return mMin + (i+0.5)*binWidth;}
   //! Retourne l'abscisse du bord superieur du bin i
-  inline float BinHighEdge(int i) const {return min + (i+1)*binWidth;} 
+  inline r_8 BinHighEdge(int_4 i) const {return mMin + (i+1)*binWidth;} 
   //! Retourne le numero du bin contenant l'abscisse x
-  inline int_4 FindBin(float x) const   
-         {return (int_4) floorf((x - min) / binWidth);}
+  inline int_4 FindBin(r_8 x) const   
+         {return (int_4) floor((x - mMin) / binWidth);}
 
   // Info, statistique et calculs sur les histogrammes
-  int       BinNonNul() const;
-  int       ErrNonNul() const;
-  int       IMax() const;
-  int       IMin() const;
-  float     VMax() const;
-  float     VMin() const;
-  float     Mean() const;
-  float     Sigma() const;
-  float     MeanLH(int il,int ih) const;
-  float     SigmaLH(int il,int ih) const;
-  float     Mean(float x0, float dx) const;
-  float     Sigma(float x0, float dx) const;
-  float     CleanedMean() const;
-  float     CleanedMean(float& sigma) const;
-  int       BinPercent(float per) const;
-  int       BinPercent(float x,float per,int& imin,int& imax);
-  int       BinPercent(float x,float per,float& xmin,float& xmax);
-  void      HInteg(float norm = 0.);
+  int_4     BinNonNul() const;
+  int_4     ErrNonNul() const;
+  int_4     IMax() const;
+  int_4     IMin() const;
+  r_8       VMax() const;
+  r_8       VMin() const;
+  r_8       Mean() const;
+  r_8       Sigma() const;
+  r_8       MeanLH(int_4 il,int_4 ih) const;
+  r_8       SigmaLH(int_4 il,int_4 ih) const;
+  r_8       Mean(r_8 x0, r_8 dx) const;
+  r_8       Sigma(r_8 x0, r_8 dx) const;
+  r_8       CleanedMean() const;
+  r_8       CleanedMean(r_8& sigma) const;
+  int_4     BinPercent(r_8 per) const;
+  int_4     BinPercent(r_8 x,r_8 per,int_4& imin,int_4& imax);
+  int_4     BinPercent(r_8 x,r_8 per,r_8& xmin,r_8& xmax);
+  void      HInteg(r_8 norm = 0.);
   void      HDeriv();
-  virtual void HRebin(int nbinew);
-
-  int       MaxiLocal(float& maxi,int& imax,float& maxn,int& imaxn);
-  float     FitMax(int degree=2, float frac=0.5f, int debug=0) const;
-  float     FindWidth(float xmax,float frac=0.5f, int debug=0) const;
-  float     FindWidth(float frac=0.5f, int debug=0) const;
-  int       EstimeMax(float& xm,int SzPav = 3);
-  int       EstimeMax(int& im,float& xm,int SzPav = 3);
-  void      EstimeWidthS(float frac,float& widthG,float& widthD);
+  virtual void HRebin(int_4 nbinew);
+
+  int_4     MaxiLocal(r_8& maxi,int_4& imax,r_8& maxn,int_4& imaxn);
+  r_8       FitMax(int_4 degree=2, r_8 frac=0.5f, int_4 debug=0) const;
+  r_8       FindWidth(r_8 xmax,r_8 frac=0.5f, int_4 debug=0) const;
+  r_8       FindWidth(r_8 frac=0.5f, int_4 debug=0) const;
+  int_4     EstimeMax(r_8& xm,int_4 SzPav = 3);
+  int_4     EstimeMax(int_4& im,r_8& xm,int_4 SzPav = 3);
+  void      EstimeWidthS(r_8 frac,r_8& widthG,r_8& widthD);
 
   // Fit
-  int    Fit(GeneralFit& gfit,unsigned short typ_err=0);
+  int_4  Fit(GeneralFit& gfit,unsigned short typ_err=0);
   Histo  FitResidus(GeneralFit& gfit);
   Histo  FitFunction(GeneralFit& gfit);
 
   // Print et Display ASCII
-  void PrintF(FILE * fp, int dyn = 100, float hmin = 1., float hmax = -1.,
-		      int pflag = 0, int il = 1, int ih = -1);
-  void Print(int dyn = 100, float hmin = 1., float hmax = -1.,
-		     int pflag = 0, int il = 1, int ih = -1);
+  void PrintF(FILE * fp, int_4 dyn = 100, r_8 hmin = 1., r_8 hmax = -1.,
+		      int_4 pflag = 0, int_4 il = 1, int_4 ih = -1);
+  void Print(int_4 dyn = 100, r_8 hmin = 1., r_8 hmax = -1.,
+		     int_4 pflag = 0, int_4 il = 1, int_4 ih = -1);
 
 protected:
   void Delete();
 
-  float*    data;     //!< donnees
-  double*   err2;	   //!< erreurs carrees
-  float     under;    //!< underflow
-  float     over;     //!< overflow
-  double    nHist;    //!< somme ponderee des entrees
-  int_4     nEntries; //!< nombre d'entrees
-  int_4     bins;     //!< nombre de bins
-  float     min;      //!< abscisse minimum
-  float     max;      //!< abscisse maximum
-  float     binWidth; //!< largeur du bin
+  r_8*   mData;    //!< donnees
+  r_8*   mErr2;	   //!< erreurs carrees
+  r_8    mUnder;   //!< underflow
+  r_8    mOver;    //!< overflow
+  r_8    nHist;    //!< somme ponderee des entrees
+  int_4  nEntries; //!< nombre d'entrees
+  int_4  mBins;    //!< nombre de bins
+  r_8    mMin;     //!< abscisse minimum
+  r_8    mMax;     //!< abscisse maximum
+  r_8    binWidth; //!< largeur du bin
 };
 
@@ -182,7 +183,7 @@
 // ObjFileIO<Histo>
 
-/*! \ingroup HiStats \fn operator*(const Histo&,double)
+/*! \ingroup HiStats \fn operator*(const Histo&,r_8)
   \brief Operateur H2 = H1 * b */
-inline Histo operator * (const Histo& a, double b)
+inline Histo operator * (const Histo& a, r_8 b)
 {
   Histo result(a);
@@ -190,7 +191,7 @@
 }
 
-/*! \ingroup HiStats \fn operator*(double,const Histo&)
+/*! \ingroup HiStats \fn operator*(r_8,const Histo&)
   \brief Operateur H2 = b * H1 */
-inline Histo operator * (double b, const Histo& a)
+inline Histo operator * (r_8 b, const Histo& a)
 {
   Histo result(a);
@@ -198,7 +199,7 @@
 }
 
-/*! \ingroup HiStats \fn operator/(const Histo&,double)
+/*! \ingroup HiStats \fn operator/(const Histo&,r_8)
   \brief Operateur H2 = H1 / b */
-inline Histo operator / (const Histo& a, double b)
+inline Histo operator / (const Histo& a, r_8 b)
 {
   Histo result(a);
@@ -206,7 +207,7 @@
 }
 
-/*! \ingroup HiStats \fn operator+(const Histo&,double)
+/*! \ingroup HiStats \fn operator+(const Histo&,r_8)
   \brief Operateur H2 = H1 + b */
-inline Histo operator + (const Histo& a, double b)
+inline Histo operator + (const Histo& a, r_8 b)
 {
   Histo result(a);
@@ -214,7 +215,7 @@
 }
 
-/*! \ingroup HiStats \fn operator+(double,const Histo&)
+/*! \ingroup HiStats \fn operator+(r_8,const Histo&)
   \brief Operateur H2 = b + H1 */
-inline Histo operator + (double b, const Histo& a)
+inline Histo operator + (r_8 b, const Histo& a)
 {
   Histo result(a);
@@ -222,7 +223,7 @@
 }
 
-/*! \ingroup HiStats \fn operator-(const Histo&,double)
+/*! \ingroup HiStats \fn operator-(const Histo&,r_8)
   \brief Operateur H2 = H1 - b */
-inline Histo operator - (const Histo& a, double b)
+inline Histo operator - (const Histo& a, r_8 b)
 {
   Histo result(a);
@@ -230,7 +231,7 @@
 }
 
-/*! \ingroup HiStats \fn operator-(double,const Histo&)
+/*! \ingroup HiStats \fn operator-(r_8,const Histo&)
   \brief Operateur H2 = b - H1 */
-inline Histo operator - (double b, const Histo& a)
+inline Histo operator - (r_8 b, const Histo& a)
 {
   Histo result(a);
